<?php
/**
Written and solely owned by Raven Web Services, LLC
Not for distribution other than by Raven Web Services, LLC
Copyright 2005-2013
**/
if (realpath(__FILE__) == realpath($_SERVER['SCRIPT_FILENAME'])) {
	header('Location: index.php');
	exit('Access Denied');
}
//
// Version define added by montego - can be used by scripts to identify RN CMS and version
// Do not change this for your site as it might mess up future features and add-ons
define('RAVENNUKE_VERSION', '025100');
// Version Friendly define added by montego and modified by raven - can be used by scripts to identify RN CMS and version
// Scripts are required to add prefixes, such as v (version) - example: echo 'v' . RAVENNUKE_VERSION_FRIENDLY would print as v02.30.01
// Do not change this for your site as it might mess up future features and add-ons
$rnf = substr(RAVENNUKE_VERSION,0,2) . '.' . substr(RAVENNUKE_VERSION,2,2) . '.' . substr(RAVENNUKE_VERSION,4,2);
if (!defined('RAVENNUKE_VERSION_FRIENDLY')) define('RAVENNUKE_VERSION_FRIENDLY', $rnf);
unset($rnf);

//Inspired by phoenix-cms at website-portals.net
//Enhanced by Raven at ravenphpscripts.com
if (!defined('NUKE_BASE_FOLDER')) {
	$path_parts = pathinfo($_SERVER['PHP_SELF']);
	define('NUKE_BASE_FOLDER', str_replace('\\/', '/', $path_parts['dirname'].'/')); //montego - modified slightly to work on some windows platforms
}
//Absolute Nuke directory
if (!defined('NUKE_BASE_DIR')) define('NUKE_BASE_DIR', dirname(__FILE__) . '/');
//Absolute Nuke directory + includes
if (!defined('NUKE_BLOCKS_DIR')) define('NUKE_BLOCKS_DIR', NUKE_BASE_DIR . 'blocks/');
if (!defined('NUKE_IMAGES_DIR')) define('NUKE_IMAGES_DIR', NUKE_BASE_DIR . 'images/');
if (!defined('NUKE_INCLUDE_DIR')) define('NUKE_INCLUDE_DIR', NUKE_BASE_DIR . 'includes/');
if (!defined('NUKE_LANGUAGE_DIR')) define('NUKE_LANGUAGE_DIR', NUKE_BASE_DIR . 'language/');
if (!defined('NUKE_MODULES_DIR')) define('NUKE_MODULES_DIR', NUKE_BASE_DIR . 'modules/');
if (!defined('NUKE_THEMES_DIR')) define('NUKE_THEMES_DIR', NUKE_BASE_DIR . 'themes/');
if (!defined('NUKE_ADMIN_DIR')) define('NUKE_ADMIN_DIR', NUKE_BASE_DIR . 'admin/');
if (!defined('NUKE_CLASSES_DIR')) define('NUKE_CLASSES_DIR', NUKE_BASE_DIR . 'classes/');
if (!defined('NUKE_ADMIN_MODULE_DIR')) define('NUKE_ADMIN_MODULE_DIR', NUKE_ADMIN_DIR . 'modules/');
if (!defined('NUKE_FORUMS_DIR')) define('NUKE_FORUMS_DIR', (defined('IN_ADMIN') ? './../' : 'modules/Forums/'));

/*********************************************************************************
* PHP Error Reporting Levels:
*
* Mainly used in mainfile.php and is directly related
* to the $display_errors setting in the main config.php file.  If $display_errors
* is set to "true" then this setting will be used by PHP.  Otherwise it will be
* ignored.  Below are the possible settings:
*
* Value   Constant                          Description
* ------  --------------------------------  ------------------------------------------------------------------------------------
* 1       E_ERROR (integer)                 Fatal run-time errors. These indicate errors that can not be recovered from,
*                                             such as a memory allocation problem.  Execution of the script is halted.
* 2       E_WARNING (integer)               Run-time warnings (non-fatal errors). Execution of the script is not halted.
* 4       E_PARSE (integer)                 Compile-time parse errors. Parse errors should only be generated by the parser.
* 8       E_NOTICE (integer)                Run-time notices. Indicate that the script encountered something that could
*                                             indicate an error, but could also happen in the normal course of running a script.
* 16      E_CORE_ERROR (integer)            Fatal errors that occur during PHP's initial startup. This is like an E_ERROR,
*                                             except it is generated by the core of PHP. (Since PHP 4.)
* 32      E_CORE_WARNING (integer)          Warnings (non-fatal errors) that occur during PHP's initial startup. This is like
*                                             an E_WARNING, except it is generated by the core of PHP.  (Since PHP 4.)
* 64      E_COMPILE_ERROR (integer)         Fatal compile-time errors. This is like an E_ERROR, except it is generated by the
*                                             Zend Scripting Engine.  (Since PHP 4.)
* 128     E_COMPILE_WARNING (integer)       Compile-time warnings (non-fatal errors).  This is like an E_WARNING, except it is
*                                             generated by the Zend Scripting Engine.  (Since PHP 4.)
* 256     E_USER_ERROR (integer)            User-generated error message. This is like an E_ERROR, except it is generated in
*                                             PHP code by using the PHP function trigger_error().  (Since PHP 4.)
* 512     E_USER_WARNING (integer)          User-generated warning message. This is like an E_WARNING, except it is generated
*                                             in PHP code by using the PHP function trigger_error().  (Since PHP 4.)
* 1024    E_USER_NOTICE (integer)           User-generated notice message. This is like an E_NOTICE, except it is generated in
*                                             PHP code by using the PHP function trigger_error().  (Since PHP 4.)
* 2048    E_STRICT (integer)                Run-time notices. Enable to have PHP suggest changes to your code which will ensure
*                                             the best interoperability and forward compatibility of your code.  (Since PHP 5.)
* 4096    E_RECOVERABLE_ERROR (integer)     Catchable fatal error. It indicates that a probably dangerous error occured, but did
*                                             not leave the Engine in an unstable state. If the error is not caught by a user
*                                             defined handle (see also set_error_handler()), the application aborts as it was
*                                             an E_ERROR.  (Since PHP 5.2.)
* 8192    E_DEPRECATED (integer)            Run-time notices. Enable this to receive warnings about code that will not work in
*                                             future versions.  (Since PHP 5.3.0.)
* 16384   E_USER_DEPRECATED (integer)       User-generated warning message. This is like an E_DEPRECATED, except it is generated in
*                                             PHP code by using the PHP function trigger_error().  (Since PHP 5.3.0.)
* 30719   E_ALL (integer)                   All errors and warnings, as supported, except of level E_STRICT in PHP < 6.  (32767 in
*                                             PHP 6, 30719 in PHP 5.3.x, 6143 in PHP 5.2.x, 2047 previously.)
*********************************************************************************/
$error_reporting = E_ALL^E_NOTICE; // This is the default and means: All errors except Notices
if (defined('E_DEPRECATED')) $error_reporting = $error_reporting^E_DEPRECATED; // If want to see these warnings when running PHP5.3, comment out this IF statement

/*********************************************************************************
* SQL Logging to Text Log File:
* Calls through db/mysqli.php only are logged.
* loglevel = 0 -> no logging (default setting)
* loglevel = 1 -> logs sql errors (with associated IP address) only
* loglevel = 2 -> logs ALL sql query statements and errors and is intended for
*                 development testing purposes only as the log file can grow
*                 rather quickly!
* loglevel = 3 -> logs sql errors (with associated IP address) and time profiling only
* loglevel = 4 -> logs ALL sql query statements, errors and time profiling, and is intended for
*                 development testing purposes only as the log file can grow
*                 rather quickly!
* set up a dblog file in your /rnlogs directory with write privileges to use this
*********************************************************************************/
$loglevel = 0;

/*********************************************************************************
* Visual Captcha Configuration for Modules (to help prevent spam):
* You need to have GD extension installed:
*   0 = No Security Code
*   1 = Require Code for Anonymous ONLY
*   2 = Require Code for Registered ONLY
*   3 = Require Code for BOTH Anonymous and Registered
* NOTE: If the module name is present (defined here), then it means that module has
* had the new visual captcha applied to it and is controlled by setting the code
* value based on the above values.
**********************************************************************************/
$modGFXChk = array(
	'Downloads' => 3,
	'Feedback' => 3,
	'News' => 3,
	'Project_Tracking' => 3,
	'Recommend_Us' => 3,
	'Reviews' => 3,
	'Submit_News' => 3,
	'Surveys' => 3,
	'Web_Links' => 3
);

/*********************************************************************************
* nukeWYSIWYG(tm) Copyright (c) 2005 Kevin Guske        http://nukeseo.com
* img tag update by Nopsych November 2006               http://www.nopsych.it
* kses developed by Ulf Harnhammar                      http://kses.sf.net
* kses enhancement ideas contributed by sixonetonoffun  http://netflake.com
* FCKeditor by Frederico Caldeira Knabben               http://fckeditor.net
* Original FCKeditor for PHP-Nuke by H.Theisen          http://phpnuker.de
*
* Advanced Editor (nukeWYSIWYG) Configuration Options:
*
* The $advanced_editor setting controls whether or not nukeWYSIWYG(tm)
* will be used.  The site-level setting is below.  But adding a similar
* setting to the modules/xxxx/index.php allows the editor to be enabled
* or disabled at the module level.
*
* The $AllowableHTML array definitions will override/overlay the $AllowableHTML
* array definitions in the standard config.php file.  This is intentional and is
* required for correct operation of the Editor.
**********************************************************************************/
$advanced_editor = 1;  // 0=Editor is turned OFF, 1=Editor is turned ON

// To override the default uploads/ folder used for storing files uploaded
// through nukeWYSIWYG via FCKeditor's filemanager.
// This should have a slash at the beginning and a slash at the end (e.g. '/files/') and is relative to the URL without subdirectories
$uploadpath = '';

$AllowableHTML = array(
	'a' => array('class' => 1, 'style' => 1, 'id' => 1, 'href' => 1, 'target' => 1, 'title' => array('minlen' => 4, 'maxlen' => 120)),
	'b' => array(),
	'blockquote' => array('class' => 1, 'style' => 1, 'id' => 1),
	'br' => array(),
	'center' => array(),
	'div' => array('class' => 1, 'style' => 1, 'id' => 1, 'align' => 1),
	'em' => array('class' => 1, 'style' => 1, 'id' => 1),
	'font' => array('face' => 1, 'style' => 1, 'color' => 1, 'size' => array('minval' => 1, 'maxval' => 7)),
	'h1'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'h2'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'h3'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'h4'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'h5'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'h6'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'hr' => array(),
	'i' => array(),
	'img' => array('class' => 1, 'style' => 1, 'id' => 1, 'alt' => 1, 'src' => 1, 'hspace' => 1, 'vspace' => 1, 'width' => 1, 'height' => 1, 'border' => 1, 'align' => 1),
	'li' => array('class' => 1, 'style' => 1, 'id' => 1),
	'ol' => array('class' => 1, 'style' => 1, 'id' => 1),
	'p' => array('class' => 1, 'style' => 1, 'id' => 1, 'align' => 1),
	'pre' => array('style' => 1, 'id' => 1, 'align' => 1, 'class' => 1, 'title' => array('minlen' => 4, 'maxlen' => 120)),
	'span' =>array('id' => 1, 'class' => 1, 'style' => array('font-family' => 1, 'color' => 1)),
	'strong' => array(),
	'strike'=>array(),
	'sub'=>array(),
	'sup'=>array(),
	'table' => array('class' => 1, 'style' => 1, 'id' => 1, 'align' => 1, 'border' => 1, 'cell' => 1, 'width' => 1, 'cellspacing' => 1, 'cellpadding' => 1),
	'tbody'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'td' => array('class' => 1, 'style' => 1, 'id' => 1, 'align' => 1, 'width' => 1, 'valign' => 1, 'height' => 1, 'rowspan' => 1, 'colspan' => 1 ),
	'tfoot'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'th' => array('class' => 1, 'style' => 1, 'id' => 1, 'align' => 1, 'scope' => 1, 'width' => 1, 'valign' => 1, 'height' => 1, 'rowspan' => 1, 'colspan' => 1),
	'thead'=>array('class' => 1, 'style' => 1, 'id' => 1),
	'tr' => array('class' => 1, 'style' => 1, 'id' => 1, 'align' => 1),
	'tt'=>array(),
	'u' => array(),
	'ul' => array('class' => 1, 'style' => 1, 'id' => 1),
);

//An array of values used when moderating comments in the news module.
$reasons = array('As Is','Offtopic','Flamebait','Troll','Redundant','Insightful','Interesting','Informative','Funny','Overrated','Underrated');

//An array of values to be filtered out by the check_words function in mainfile.php
$CensorList = array('fuck','cunt','fucker','fucking','pussy','cock','c0ck','cum','twat','clit','bitch','fuk','fuking','motherfucker');

/*********************************************************************************
* NukeSentinel(tm) Configuration Options:
*
* $bypassNukeSentinelInvalidIPCheck: Debug control to bypass NukeSentinel(tm)
*                                    InvalidIP check when set to "true".  Leave
*                                    this "false" for production sites.
* $bypassInstallationFolderCheck:    Debug control to bypass RavenNuke(tm)
*                                    setup/runtime check when set to "true".  Leave
*                                    this "false" for production sites.
**********************************************************************************/
$bypassNukeSentinelInvalidIPCheck = false;  // This should only be used (set to "true") when testing locally and not in a production environment
$bypassInstallationFolderCheck    = false;  // This should only be used (set to "true") when testing locally and not in a production environment

/*********************************************************************************
* TegoNuke(tm) ShortLinks Configuration Options:
**********************************************************************************/
$tnsl_bUseShortLinks   = false;  // Setting this to "true" will cause RavenNuke(tm) to shorten the URLs in GoogleTap/GTNG fashion.
$tnsl_bAutoTapBlocks   = false;  // Setting this to "true" will cause RavenNuke(tm) to shorten the URLs automatically for block files.
$tnsl_bAutoTapLinks    = false;  // Setting this to "true" will cause RavenNuke(tm) to search for additional untapped links and attempt to shorten them - could slow down your site
$tnsl_bDebugShortLinks = false;  // Setting this to "true" will cause the ShortLinks function to display debugging information.

/*********************************************************************************
* Registration Options:
**********************************************************************************/
$forceLowerCaseUserName = false;  // Setting this to "true" will force new usernames to be lower case only.

/*********************************************************************************
* For nukeFEED(tm) - Some sites may use non-UTF-8 databases created with multi-byte
* languages. If you see strange characters when view a feed preview on the block,
* preview page or auto-discovery links, you may disable UTF-8 encoding by
* setting nf_CONVERTENCODING to false
**********************************************************************************/
define('nf_CONVERTENCODING', false);
define('nf_ENABLEUPDATECHECK', true);

/*********************************************************************************
* Pagination Control:
* Currently only implemented for the News module, but could possibly be added
* elsewhere in future releases.
**********************************************************************************/
$usePaginatorControl = true;  // Setting this to "true" turns on the pagination links
$cfgPaginatorControl = array( // Do NOT remove any of these options, just change the settings!
	'bShowPageOf'     => true,  // "true" = show Page n of NN, "false" = do not show
	'bShowTotalItems' => true,  // "true" = show out of total items, "false" = do not show
	'bShowJumpTo'     => true,  // "true" = show Jump to page, "false" = do not show
	'iJumpType'       => 1,     // 0 = user enters page number and clicks a GO button, 1 = shows a drop down of page numbers to jump to automatically.
	'bNoFollow'       => true,  // "true" = will add rel="nofollow" to the links, "false" = does not add
	'iMaxPages'       => 5,     // Number of pages to show before and after the current page
	'iPosition'       => 2,     // 0 = show pagination controls only at the top, 1 = only at the bottom, 2 = both top and bottom
);

/*********************************************************************************
* nukePIE(tm)
* http://www.nukeSEO.com
* Copyright  2007 by Kevin Guske
**********************************************************************************
* BoxOver with nukePIE:
* true  = Display full HTML description of feed item as Boxover tooltip /popup
* false = Display text-only description as title tag on feed link
**********************************************************************************/
$useBoxoverWithnukePIE = true;

/************************************************************************
 * nukeNAV(tm)
 * http://www.nukeSEO.com
 * Copyright 2009 by Kevin Guske
 ************************************************************************/
/* Use nukeNAV(tm) - note, this is required to use nukeSEO DH
 * 0  = Do not display nukeNAV top menu
 * 1  = Display nukeNAV top menu for admins only
 * 2  = Display nukeNAV top menu for all visitors
 ************************************************************************/
$usenukeNAV = 2;
$showAdminMenu = true; // Use "false" to hide the Super User (upper) portion of the ACP when nukeNAV(tm) is in use

/*********************************************************************************
* Miscellaneous System Switches:
**********************************************************************************/
$statisticsExcludeList = array('admin'); // Use to exclude gathering statistics: 'admin' implies any admin, add normal usernames to exclude as additional array elements
$disableCSRFChecking = false; // Set to "true" in order to disable Cross-Site Request Forgery (CSRF) attack protection - should ONLY use as a last resort if your environment does not allow for output buffering

//This will not remove depricated warning, but will make it PHP 6 compatable.
//We do not like suppressing errors, but there is no other way as PHP 5.3+ will produce warnings.
if (!version_compare(phpversion(), '6.0.0') >= 0) {
	@set_magic_quotes_runtime(0); // Disable magic_quotes_runtime
	@ini_set('allow_call_time_pass_reference', true); // PHP5 may/will throw a warning so this will suppress it
}

?>